<?php

namespace Drupal\lupus_ce_renderer\EventSubscriber;

use Drupal\Core\Routing\RouteSubscriberBase;
use Drupal\Core\Routing\RoutingEvents;
use Symfony\Component\Routing\RouteCollection;

/**
 * Alters routes.
 */
class CustomElementsRouteSubscriber extends RouteSubscriberBase {

  /**
   * {@inheritdoc}
   */
  protected function alterRoutes(RouteCollection $collection) {
    // Provide a CE variant of the node preview route.
    $route = $collection->get('entity.node.preview');
    $ce_route = clone $route;
    $ce_route->setRequirement('_format', 'custom_elements');
    $ce_route->setDefault('_controller', '\Drupal\lupus_ce_renderer\Controller\CustomElementsController::entityPreview');
    $collection->add('custom_elements.entity.node.preview.', $ce_route);
  }

  /**
   * {@inheritdoc}
   */
  public static function getSubscribedEvents() {
    $events[RoutingEvents::ALTER] = ['onAlterRoutes', 0];
    return $events;
  }

}
