<?php

namespace Drupal\lupus_ce_renderer\Routing;

use Drupal\Core\Routing\FilterInterface;
use Drupal\Core\Routing\RequestFormatRouteFilter;
use Drupal\Core\Site\Settings;
use Symfony\Component\Routing\RouteCollection;

/**
 * Overrides the request format route filter to change the default format.
 */
class CustomElementsRequestFormatRouteFilter extends RequestFormatRouteFilter implements FilterInterface {

  /**
   * {@inheritDoc}
   */
  protected static function getDefaultFormat(RouteCollection $collection) {
    $default = parent::getDefaultFormat($collection);
    // Default to 'custom_elements' instead of 'html' when enabled.
    if ($default == 'html' && Settings::get('lupus_ce_renderer_enable', TRUE)) {
      $default = 'custom_elements';
    }
    return $default;
  }

}
